/* 
 * This program opens a text file and transfers its non-empty lines to a user-defined
 * output file.
 * NOTE: See the below comment involving getline() function !!! 
 */

#include <iostream>
#include <fstream>
#include "prompt.h"

using namespace std;

void processFile(ifstream &input, ofstream &output)
{
	string strLine;

	while (getline(input,strLine))
	{
		if (strLine != "")
        {
			output << strLine << endl; 
            // Since getline() function does not read the newline character(\n), 
            // but reads until it, while extracting a line from a file, we add 
            // a separate newline character by using "endl" keyword as seen in this line.
        }
    }
}

int main()
{
	ifstream input;
	ofstream output;
	string strLine;

	string inFileName = PromptString("enter input file name : ");
	string outFileName = PromptString("enter output file name : ");

	input.open(inFileName.c_str());
	if (input.fail())
	{
		cout << "Error: Cannot open file "<< inFileName << endl ;
	}
	else
	{
		output.open(outFileName.c_str());
		if (output.fail())
		{
			cout << "Error: Cannot open file " << outFileName << endl ;
		}
		else
		{
			processFile(input,output);
		}
		output.close();
	}
	return 0;
}

