/*
 * Counts the number of words on each line of an input file.
 * Reads each line into a string with getline().
 *
 * Then opens an input string stream bound to that string.
 *
 * Using the string stream, reads each word in the input string.
 * Prints the number of words in each line to an output file
 */
#include <iostream>
#include <fstream>
#include <sstream>
#include <string>
#include "strutils.h"
#include "prompt.h"

int main() 
{	
	ifstream input;
	string ifName;
	

	ifName = PromptString("Please Enter the File Name: ");
	input.open(ifName.c_str());
		
	if (input.fail()) 
	{
		cout << "Error! input file cannot be opened" << endl;
	}
	else 
	{	
		ofstream output("output.txt");

		if (output.fail()) 
		{
			cout << "Could not open the output file... Exiting!" << endl;
		}
		else 
		{	
			int lineCounter = 0;
			
			string line;
			while (getline(input, line)) 
			{	
				lineCounter++;
				istringstream strStream(line);
				int wordCounter = 0;
				
				string word;
				while (strStream >> word) 
				{	
					wordCounter++;
				}
				output << "Number of words on line # " << lineCounter 
                        << " =  " << wordCounter << endl;
				
			}
			
			input.close();
			output.close();
		}
	}
	return 0;
}