/* 
 * This program seeks for the max. repeated word in a given text file.
 * To do this it uses two separate file pointers to reach the words in the file.
 * Outer file stream reads a word from the input file, 
 * the other file stream scans the same file from beginning to end for that word.
 * And also the code includes a simple progress bar just to make the program more interesting 
 */ 

#include <iostream>
#include <string>
#include <fstream>
using namespace std;

#include "prompt.h"

int getCount(ifstream &input, string wordOuter)
{
	string wordInner;
	int count = 0;

	while (input >> wordInner)
	{
		if (wordInner == wordOuter)
		{
			count++;
		}
	}

	return count;
}

int main()
{
    int maxOccurs = 0;
    int wordCount = 0;

    string wordOuter, wordInner, maxWord; 

    string filename = PromptString("enter file name: ");
    
	ifstream outer, inner;

    outer.open(filename.c_str());
	inner.open(filename.c_str());

	while (outer >> wordOuter)
	{
		wordCount++;

		inner.clear();
		inner.seekg(0);

		/*
		 * An alternative to going to the beginning of the file using seekg(0) is the following:
		 *  - before getting count of a word open input file via "inner.open(filename.c_str());"
		 *  - after getting count of a word clear flags by writing "inner.clear();"
		 *  - after clearing flags close the file by writing "inner.close();"
		 */
		
		int count = getCount(inner, wordOuter);

		/*
		 * An alternative to going to the beginning of the file using seekg(0) is the following:
		 *  - before getting count of a word open input file via "inner.open(filename.c_str());"
		 *  - after getting count of a word clear flags by writing "inner.clear();"
		 *  - after clearing flags close the file by writing "inner.close();"
		 */
		
		if (count > maxOccurs)
		{
			maxOccurs = count;
			maxWord = wordOuter;
		}

		if (wordCount % 10 == 0)      
        {   
            cout << ".";
            if (wordCount % 200 == 0) 
            {
				cout << endl;
            }
        }
	}
	
	cout << endl << endl << "word \"" << maxWord << "\" occurs " 
         << maxOccurs << " times" << endl;

    return 0;
}
